#include "AlesApplication.h"
#include <Entry.h>
#include <Path.h>
#include <FindDirectory.h>
#include <TrackerAddon.h>
#include <Entry.h>
#include <Alert.h>
#include <Deskbar.h>
#include "AlesWindow.h"

//デスクバーの位置を避けてウィンドウを配置する
//木坂さんのところからのぱくり
BPoint StandardWindowLocation()
{
	BPoint aResult(60.0 + 20.0, 60.0 + 20.0);
	BRect aDeskbarFrame(BDeskbar().Frame());
	
	if (aDeskbarFrame.Contains(aResult))
		aResult.x += 60.0;
	
	aResult += BPoint(5.0, 24.0);
	
	return aResult;
}

//Tracker Add-onはTrackerからこの関数を通して呼び出される
//dir_refは開いているフォルダ
//msgには選択しているエントリが含まれる
//３つ目はよくわからない
void process_refs(entry_ref dir_ref, BMessage *msg, void *)
{
	//とりあえず開いているフォルダを渡すことにする
	entry_ref refToOpen = dir_ref, selectedRef;
	type_code type;
	int32 count;
	msg->GetInfo("refs", &type, &count);
	
	//いくつか選択しているときは、選択した中で始めのフォルダを渡す。
	//フォルダを選択していなければ開いているフォルダを渡す。
	for (int32 i = 0; msg->FindRef("refs", i, &selectedRef) == B_OK; i++)
	{
		BEntry entry(&selectedRef, true);
		BNode node(&entry);
		//フォルダが見つかったら検索終わり
		if (node.IsDirectory() == true)
		{
			refToOpen = selectedRef;
			break;
		}
	}
	BRect frame(100, 100, 300, 300);
	frame.OffsetTo(StandardWindowLocation());
	AlesWindow *window = new AlesWindow(frame, "Graphic Viewer",
		B_TITLED_WINDOW_LOOK, B_NORMAL_WINDOW_FEEL,
		B_ASYNCHRONOUS_CONTROLS,
		refToOpen);
	window->Show();
	status_t sts;
	//スレッドを待たないと落ちてしまう
	//ちゃんとBeBookにも書いて欲しい
	//実はBeNewsletterには載っていたんだけど
	//Be Newsletter Volume II Issue 10
	//私はTrackerGrepのソースから見つけました
	wait_for_thread(window->Thread(), &sts);
}


int main()
{
	AlesApplication app;
	app.Run();
	return 0;
}

AlesApplication::AlesApplication()
	: BApplication("application/x-vnd.muramoto-Ales")
{
	fOpened = false;
}

void AlesApplication::ReadyToRun()
{
	//まだウィンドウを開いていないときにだけ
	//新しくウィンドウを開く
	if (fOpened == false)
	{
		BRect frame(100, 100, 300, 300);
		frame.OffsetTo(StandardWindowLocation());
		AlesWindow *window = new AlesWindow(frame, "Graphic Viewer",
			B_TITLED_WINDOW_LOOK, B_NORMAL_WINDOW_FEEL,
			B_ASYNCHRONOUS_CONTROLS | B_QUIT_ON_WINDOW_CLOSE,
			entry_ref());
		window->Show();
	}
}

void AlesApplication::RefsReceived(BMessage *message)
{
	entry_ref ref;
	status_t sts;
	if (message->FindRef("refs", &ref) == B_OK)
	{
		BEntry entry(&ref, true);
		BEntry parent;
		sts = entry.GetParent(&parent);
		if (sts != B_OK) return;
		entry_ref dir_ref;
		sts = parent.GetRef(&dir_ref);
		if (sts != B_OK) return;
		//Trackerが使うprocess_refs関数を有効利用しようと思ったが
		//別スレッドを作らないといけないようで面倒くさくてやめた
		fOpened = true;
		BRect frame(100, 100, 300, 300);
		frame.OffsetTo(StandardWindowLocation());
		AlesWindow *window = new AlesWindow(frame, "Graphic Viewer",
			B_TITLED_WINDOW_LOOK, B_NORMAL_WINDOW_FEEL,
			B_ASYNCHRONOUS_CONTROLS | B_QUIT_ON_WINDOW_CLOSE,
			dir_ref);
		window->Show();
	}	
}
