#ifndef FILE_COLLECTOR_H
#define FILE_COLLECTOR_H

#include <list>
#include <Entry.h>

enum
{
	NAME = 'key0',
	SIZE,
	CREATION_TIME,
	MODIFICATION_TIME,
	ACCESS_TIME
};

class FileCollector
{
public :
	FileCollector(entry_ref dir, const char *type);
	~FileCollector();
	status_t GetNextRef(entry_ref *ref);
	status_t GetPrevRef(entry_ref *ref);
	entry_ref GetDirectory();
	void AddType(const char *type);
	void ResetTo(entry_ref dir, const char *type);
	void SetPosition(entry_ref ref);
	int32 Count();
	void SortBy(uint32 key, bool reverse = false);
	void ResetPosition();
private :
	void Collect(const char *type);
	void Sort();
	list<entry_ref> fList;
	list<entry_ref>::iterator fIterator;
	entry_ref fDirectory;
	bool fFirstAccess;
	uint32 fSortKey;
	bool fReverseSort;
};

#endif //FILE_COLLECTOR_H