#include "MFileUtils.h"
#include <Node.h>
#include <NodeInfo.h>
#include <Mime.h>
#include <String.h>

bool MFileUtils::IsThisType(entry_ref *ref, const char *type_str)
{
	if (type_str == NULL) return false;
	BString string(type_str);
	BEntry entry(ref, true);
	BNode node(&entry);
	BNodeInfo info(&node);
	char type[B_MIME_TYPE_LENGTH];
	//FAT上のディレクトリにはMIMEタイプがつかないようなので、その対策
	if (string.ICompare("application/x-vnd.Be-directory") == 0)
	{
		if (node.IsDirectory())
			return true;
	}
	info.GetType(type);
	if (string.ICompare(type) == 0) return true;
	BMimeType mime(type), super;
	status_t sts = mime.GetSupertype(&super);
	if (sts != B_OK) return false;
	if (string.ICompare(super.Type()) == 0) return true;
	return false;
}
