// a settings file class.
// Copyright (c) 1999-2000, Be Incoporated. All Rights Reserved.
//Modified by muramoto@geocities.co.jp
//SetX functions are added from TPreference
//TPreference is also by Be, Inc.
#ifndef _SETTINGSFILE_H_
#define _SETTINGSFILE_H_

#include <Message.h>
#include <FindDirectory.h>
#include <Path.h>

struct attr_info;

class SettingsFile : public BMessage {
public :
	SettingsFile(char const*leafname=NULL,char const*basename=NULL,directory_which dir=B_USER_SETTINGS_DIRECTORY);
	virtual ~SettingsFile();

	status_t InitCheck() const;

	status_t Load();
	status_t Save() const;
	
	status_t		SetBool(const char *name, bool b);
	status_t		SetInt8(const char *name, int8 i);
	status_t		SetInt16(const char *name, int16 i);
	status_t		SetInt32(const char *name, int32 i);
	status_t		SetInt64(const char *name, int64 i);
	status_t		SetFloat(const char *name, float f);
	status_t		SetDouble(const char *name, double d);
	status_t		SetString(const char *name, const char *string);
	status_t		SetPoint(const char *name, BPoint p);
	status_t		SetRect(const char *name, BRect r);
	status_t		SetMessage(const char *name, const BMessage *message);
	status_t		SetFlat(const char *name, const BFlattenable *obj);


private:
	static status_t _StoreAttributes(BMessage const*m,BFile*f,const char*basename="");
	static status_t _ExtractAttribute(BMessage*m,BFile*f,const char*full_name,char*partial_name,attr_info*ai);

	status_t check;
	BPath path;
};

#endif

